package info.aspirecn.rdc.iov.sjjh.servicenode.supplier.utils;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import info.aspirecn.rdc.aspirecloud.node.except.utils.ErrorUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Map;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Slf4j
@Component
public class VehicleJsonHelper {
    private Map<String, String> millageObject;
    private Map<String, Integer> totalMileObject;
    private JSONObject earliestOrderMonthObject;

    private String getJson(String path) {
        InputStream is = this.getClass().getResourceAsStream(path);
        if (is == null) {
            return "";
        }
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        String s;
        StringBuilder configContentStr = new StringBuilder();
        try {
            while ((s = br.readLine()) != null) {
                configContentStr.append(s);
            }
        } catch (IOException e) {
            ErrorUtils.captureException(e);
            log.info("supplier10000036.getJson Exception=", e);
        }
        return configContentStr.toString();
    }

    public Map<String, String> getMillage() {
        if (millageObject != null) {
            return millageObject;
        }

        millageObject = JSON.parseObject(getJson("/config/millage.json"), Map.class);
        return millageObject;
    }

    public Map<String, Integer> getTotalMile() {
        if (totalMileObject != null) {
            return totalMileObject;
        }
        totalMileObject = JSON.parseObject(getJson("/config/totalMile.json"), Map.class);
        return totalMileObject;
    }

    public JSONObject getEarliestOrderMonthMap() {
        if (earliestOrderMonthObject != null) {
            return earliestOrderMonthObject;
        }

        earliestOrderMonthObject = JSON.parseObject(getJson("/config/earliestOrderMonth.json"));
        return earliestOrderMonthObject;
    }
}
